#include "MongoConnection.h"

MongoConnection::MongoConnection(){
	withExc = false;
}

MongoConnection::~MongoConnection() {
	if (_pScopedConn != NULL) {
		if(withExc){
			_pScopedConn->done();
			delete _pScopedConn;
			_pScopedConn = NULL;
		}
	}

}


void MongoConnection::connectReplicaSet() throw (DBException) {
	_pScopedConn =  ScopedDbConnection::getScopedDbConnection("test1/172.16.254.27:27017,172.16.254.8:27017,172.16.254.9:27017");
	try{
		_pReplicaSet = &(_pScopedConn->conn());
		if(_pReplicaSet != NULL)
		{
			_connected = true;
		}
		if (!_connected) {
			throw DBException("Error!", 1);
		}
	}catch(SocketException &exc){
		throw DBException(exc.getInfo());
	}
}

void MongoConnection::insert(string databaseCollectionNS, BSONObj bsonRecord) throw (DBException){
	_pReplicaSet->insert(databaseCollectionNS, bsonRecord);
}

auto_ptr<DBClientCursor> MongoConnection::query(string databaseCollectionNS, Query queryObj) throw (DBException){
	auto_ptr<DBClientCursor> cursor;
	try{
		cursor = _pReplicaSet->query(databaseCollectionNS, queryObj);
	}catch(DBException &exc){
		cerr<<"exception in query"<<endl;
		throw exc;
	}
	if (cursor.get() == NULL){
		throw DBException("null pointer", 1);
	}else{
		return cursor;
	}
}

void MongoConnection::update(string databaseCollectionNS, BSONObj id, BSONObj dataToUpdate) throw (DBException){
	_pReplicaSet->update(databaseCollectionNS, id, dataToUpdate);
}
