#ifndef MONGOCONNECTION_H_
#define MONGOCONNECTION_H_

#include <string>
#include "mongo/client/dbclient.h"
#include "mongo/client/connpool.h"
#include "mongo/util/net/hostandport.h"

using namespace std;
using namespace mongo;

class MongoConnection {
public:
	MongoConnection();
	~MongoConnection();
	void insert(string databaseCollectionNS, BSONObj bsonRecord) throw (DBException);
	auto_ptr<DBClientCursor> query(string databaseCollectionNS, Query queryObj) throw (DBException);
	void update(string databaseCollectionNS, BSONObj id, BSONObj dataToUpdate) throw (DBException);
	void connectReplicaSet() throw (DBException);
	bool withExc;
private:
	ScopedDbConnection* _pScopedConn;
	DBClientBase* _pReplicaSet;
	bool _connected;
};

#endif /* MONGOCONNECTION_H_ */
