#include <iostream>
#include "MongoConnection.h"
using namespace std;
void inserting(MongoConnection mConnect) throw (DBException);
void querying(MongoConnection mConnect) throw (DBException);

int main() {
	while(true){
		MongoConnection mConnect;
		try{
			mConnect.connectReplicaSet();
			inserting(mConnect);
			querying(mConnect);

		}catch(...){
			mConnect.withExc = true;
		}
	}
	mongo::ReplicaSetMonitor::remove("test1", true);
	return 0;
}

void inserting(MongoConnection mConnect) throw (DBException){
	try{
		for(int i=0; i<100; i++)
		{
			 stringstream ss;
			 ss << i;
			 stringstream age;
			 age << (i+10);
			 BSONObj bsonObj = BSONObjBuilder().append("_id", ss.str()).append("name", ss.str()).append("age", age.str()).obj();
			 mConnect.insert("test.people", bsonObj);
		}
	}catch(DBException &exc){
		cerr<<"exception in inserting"<<endl;
		throw exc;
	}
}


void querying(MongoConnection mConnect) throw (DBException){
	while(true){
		auto_ptr<DBClientCursor> cursor;

		for(int i=0; i<10; i++)
		{
			stringstream ss;
			ss << i;
			try
			{
				cursor = mConnect.query("test.people", QUERY("_id" << ss.str()));
				if (cursor.get() == NULL)
				{
					throw DBException("null pointer", 1);
				}
				 while(cursor->more()) {
					 BSONObj bsonObj;
					  try
					  {
						  bsonObj = cursor->nextSafe();
					  }
					  catch(AssertionException &exc)
					  {
						 throw DBException(exc.getInfo());
					  }
					  cout<<"id: "<<bsonObj.getStringField("_id")<<endl;
					  cout<<"name: "<<bsonObj.getStringField("name")<<endl;
					  cout<<"age: "<<bsonObj.getStringField("age")<<endl;
				 }
			}
			catch(DBException &exc)
			{
				 cerr<<"exception in querying"<<endl;
				 throw exc;
			}
		}
	}
}
